(function ($) {
  "use strict";

  var script_src = document.currentScript && document.currentScript.src;

  $(window).load(function () {
    var form_id = $("#wp-submit").closest("form").attr("id");

    if (form_id === "loginform") {
      $("#wp-submit").prop("value", "Verify with GetOTP");
    }

    var url = new URL(script_src);

    var params = new URLSearchParams(url.search);

    var display = params.get("display");

    if (display === "embed") {
      getotp.init();

      $("#loginform").one("submit", function (event) {
        event.preventDefault();

        var username = $("#user_login").val();
        var password = $("#user_pass").val();

        var payload = {
          username: username,
          password: password,
        };

        var form = $(this);

        loginWithOtp(payload, form);
      });
    }

    function loginWithOtp(payload, form) {
      payload["action"] = "getotp_ajax_login_with_otp";

      return $.ajax({
        type: "POST",
        url: wp_ajax.ajax_url,
        data: payload,
        dataType: "json",
        beforeSend: function () {},
        success: function (response) {
          var otp_url = response.otp_url;

          // call GetOTP embed

          getotp.showModal(otp_url);

          getotp.onSuccess(function (payload) {
            var otp_id = payload.otp_id;
            var redirect_url = payload.redirect_url;

            window.location.href = redirect_url;
          });
        },
        error: function (xhr, status, error) {
          // when error, fallback as normal form submit
          form.submit();
        },
        complete: function () {},
      });
    }
  });
})(jQuery);
